#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include <stdbool.h>
#include <unistd.h>
#include <termios.h>
#include <limits.h>
#include <time.h>
#include <sys/time.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>

#include "structure.h"
#include "cars.h"
#include "base.h"

int currentTurn;
int nPlayers;
carData* players;

void init_all(int nPl) {
    nPlayers = nPl;
    currentTurn = 0;
    players = malloc(sizeof(carData)*nPlayers);
    for(int p = 0; p < nPlayers; p++) {
        players[p].curChunk = start;
        players[p].c = init_car("player");
    }
}

void destroy_all() {
    for(int p = 0; p < nPlayers; p++) {
        destroy_car(players[p].c);
    }
    free(players);
}

int ln_baseN(int n, int b) {
    if(n<b) {
        return 0;
    }
    return 1+ln_baseN(n/b, b);
}
int notLN(int n, int b) {
    int r = 0;
    while(n != 0) {
        n = n/b;
        r++;
    }
    return r;
}
int convex_seg(int x1, int x2, double theta) {
    return (int)(((1.0f - theta) * x1 + theta * x2));
}
double to_double(int n) {
    return (double)n;
}
int pw(int x, int n) {
    if (n<0)
        return 0;
    if (n==0)
        return 1;
    if (n%2==0)
        return pw(x*x, n/2);
    return x*pw(x*x, n/2);
}
double distance_pt(int x1, int x2, int y1, int y2) {
    return sqrt(to_double(pw(x2 - x1, 2) + pw(y2 - y1, 2)));
}
int max(int a, int b) {return (a>b)?(a):(b);}
int min(int a, int b) {return (a<b)?(a):(b);}