#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include <stdbool.h>
#include <unistd.h>
#include <termios.h>
#include <limits.h>
#include <time.h>
#include <sys/time.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>

#include "structure.h"
#include "base.h"
#include "display.h"
#include "rooms.h"
#include "cars.h"

const int WIDTH = 1000;
const int HEIGHT = 800;

const int N_PLAYERS = 4;

int main() {
    srand(time(NULL));
    if (SDL_Init(SDL_INIT_EVERYTHING) != 0) {
        printf("error initializing SDL: %s\n", SDL_GetError());
    }
    SDL_Window* win = SDL_CreateWindow("Game",
                                       SDL_WINDOWPOS_CENTERED,
                                       SDL_WINDOWPOS_CENTERED,
                                       WIDTH, HEIGHT, 0);
 
    Uint32 render_flags = SDL_RENDERER_ACCELERATED;
    SDL_Renderer* rend = SDL_CreateRenderer(win, -1, render_flags);
    SDL_SetRenderDrawBlendMode(rend, SDL_BLENDMODE_BLEND);

    import_letters(rend);
    import_digits(rend);
    init_rooms();
    init_all(N_PLAYERS);
    // ---------------------------- //
    

    usleep(1000000);
    // ---------------------------- //
    free_digits(digits);
    free_digits(letters);
    destroy_rooms();

    SDL_DestroyRenderer(rend);
    SDL_DestroyWindow(win);
    SDL_Quit();
    return 0;
}

/* TODO :
    - add display
    - add collisions
    - add level parsing/generation
    - add player input parsing (and some dumb code to test it)
    - add function that gives players the necessary data to play
    - check seg faults
    + add items
    + add hazards
*/