#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include <stdbool.h>
#include <unistd.h>
#include <termios.h>
#include <limits.h>
#include <time.h>
#include <sys/time.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>

#include "structure.h"
#include "base.h"
#include "rooms.h"

chunk* start;
chunk** allRooms;
int nMaxRooms;
int curRoom;

int build_empty_room(int CX, int CY, int w, int h, chunk* north, chunk* east, chunk* south, chunk* west) {
    if(curRoom < nMaxRooms) {
        chunk* res = malloc(sizeof(chunk));
        res->north = north;
        res->east = east;
        res->south = south;
        res->west = west;
        res->chW = w;
        res->chH = h;
        res->chX = CX;
        res->chY = CY;

        res->rects = malloc(sizeof(rectangle)*32);
        res->nRects = 0;
        res->circles = malloc(sizeof(circle)*32);
        res->nCircles = 0;

        allRooms[curRoom] = res;
        curRoom += 1;
        return (curRoom-1);
    } else {
        fprintf(stderr, "ERROR : all rooms are filled, cannot create a new one\n");
        return (-1);
    }
}

void init_rooms() {
    nMaxRooms = 128;
    curRoom = 0;
    allRooms = malloc(sizeof(chunk*)*nMaxRooms);

    int id0 = build_empty_room(0, 0, 500, 500, NULL, NULL, NULL, NULL);
    start = allRooms[id0];
}

void destroy_rooms() {
    for(int r = 0; r < curRoom; r++) {
        free(allRooms[r]->circles);
        free(allRooms[r]->rects);
        free(allRooms[r]);
    }
    free(allRooms);
}